Loading...
Searching...
No Matches
XrdOssDFHandler Class Reference

`#include <XrdOssHandler.hh>`

Inheritance diagram for XrdOssDFHandler:
Collaboration diagram for XrdOssDFHandler:

## Public Member Functions

| XrdOssDFHandler (XrdOssDF *successor)
virtual | ~XrdOssDFHandler ()
virtual int | Close (long long *retsz=0)
virtual int | Fchmod (mode_t Mode)
virtual int | Fctl (int cmd, int alen, const char *args, char **resp=0)
virtual void | Flush ()
| Flush filesystem cached pages for this file (used for checksums).
virtual int | Fstat (struct stat *buff)
virtual int | Fsync ()
virtual int | Fsync (XrdSfsAio *aiop)
virtual int | Ftruncate (unsigned long long flen)
virtual int | getFD ()
virtual off_t | getMmap (void **addr)
virtual const char * | getTID ()
virtual int | isCompressed (char *cxidp=0)
virtual int | Open (const char *path, int Oflag, mode_t Mode, XrdOucEnv &Env)
virtual int | Opendir (const char *dir_path, XrdOucEnv &Env)
virtual ssize_t | pgRead (void *buffer, off_t offset, size_t rdlen, uint32_t *csvec, uint64_t opts)
virtual int | pgRead (XrdSfsAio *aioparm, uint64_t opts)
virtual ssize_t | pgWrite (void *buffer, off_t offset, size_t wrlen, uint32_t *csvec, uint64_t opts)
virtual int | pgWrite (XrdSfsAio *aioparm, uint64_t opts)
virtual ssize_t | Read (off_t offset, size_t blen)
virtual ssize_t | Read (void *buff, off_t offset, size_t blen)
virtual int | Read (XrdSfsAio *aiop)
virtual int | Readdir (char *buff, int blen)
virtual ssize_t | ReadRaw (void *buff, off_t offset, size_t blen)
virtual ssize_t | ReadV (XrdOucIOVec *readV, int n)
virtual int | StatRet (struct stat *buff)
virtual ssize_t | Write (const void *buff, off_t offset, size_t blen)
virtual int | Write (XrdSfsAio *aiop)
virtual ssize_t | WriteV (XrdOucIOVec *writeV, int n)
Public Member Functions inherited from XrdOssDF
| XrdOssDF (const char *tid="", uint16_t dftype=0, int fdnum=-1)
virtual | ~XrdOssDF ()
uint16_t | DFType ()

## Protected Attributes

XrdOssDF * | successor_
Protected Attributes inherited from XrdOssDF
uint16_t | dfType
int | fd
off_t | pgwEOF
short | rsvd
const char * | tident

## Additional Inherited Members

Static Public Attributes inherited from XrdOssDF
static const uint16_t | DF_isDir = 0x0001
| Object is for a directory.
static const uint16_t | DF_isFile = 0x0002
| Object is for a file.
static const uint16_t | DF_isProxy = 0x0010
| Object is a proxy object.
static const uint64_t | doCalc = 0x4000000000000000ULL
| pgw: Calculate checksums
static const int | Fctl_ckpObj = 0
static const int | Fctl_utimes = 1
static const uint64_t | Verify = 0x8000000000000000ULL
| all: Verify checksums

## Detailed Description

Definition at line 41 of file XrdOssHandler.hh.

## Constructor & Destructor Documentation

## XrdOssDFHandler()

XrdOssDFHandler::XrdOssDFHandler | ( | XrdOssDF * | successor | ) |

inline

Definition at line 77 of file XrdOssHandler.hh.

: XrdOssDF(successor->getTID(), successor->DFType(), successor->getFD()), successor_(successor) { }
XrdOssDFHandler::successor_
XrdOssDF * successor_
Definition XrdOssHandler.hh:81
XrdOssDF::getTID
virtual const char * getTID()
Definition XrdOss.hh:434
XrdOssDF::XrdOssDF
XrdOssDF(const char *tid="", uint16_t dftype=0, int fdnum=-1)
Definition XrdOss.hh:444
XrdOssDF::getFD
virtual int getFD()
Definition XrdOss.hh:426
XrdOssDF::DFType
uint16_t DFType()
Definition XrdOss.hh:396

References XrdOssDF::XrdOssDF(), XrdOssDF::DFType(), getFD(), getTID(), and successor_.

Referenced by XrdOssCsiDir::XrdOssCsiDir(), and XrdOssCsiFile::XrdOssCsiFile().

Here is the call graph for this function:
Here is the caller graph for this function:

## ~XrdOssDFHandler()

virtual XrdOssDFHandler::~XrdOssDFHandler | ( |  | ) |

inline virtual

Definition at line 78 of file XrdOssHandler.hh.

{ delete successor_; }

References successor_.

## Member Function Documentation

## Close()

virtual int XrdOssDFHandler::Close | ( | long long * | retsz = 0 | ) |

inline virtual

Close a directory or file.

Parameters

  retsz | If not nil, where the size of the file is to be returned.

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Implements XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 73 of file XrdOssHandler.hh.

{ return successor_->Close(retsz); }

References successor_.

## Fchmod()

virtual int XrdOssDFHandler::Fchmod | ( | mode_t | mode | ) |

inline virtual

Change file mode settings.

Parameters

  mode | - The new file mode setting.

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Definition at line 49 of file XrdOssHandler.hh.

{ return successor_->Fchmod(Mode); }
Mode
int Mode
Definition XrdSecgsiProxy.cc:94

References Mode, and successor_.

## Fctl()

virtual int XrdOssDFHandler::Fctl | ( | int | cmd,
|  | int | alen,
|  | const char * | args,
|  | char ** | resp = 0 )

inline virtual

Reimplemented from XrdOssDF.

Definition at line 74 of file XrdOssHandler.hh.

{ return successor_->Fctl(cmd, alen, args, resp); }

References successor_.

## Flush()

virtual void XrdOssDFHandler::Flush | ( |  | ) |

inline virtual

Flush filesystem cached pages for this file (used for checksums).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 50 of file XrdOssHandler.hh.

{ successor_->Flush(); }

References successor_.

## Fstat()

virtual int XrdOssDFHandler::Fstat | ( | struct stat * | buf | ) |

inline virtual

Return state information for this file.

Parameters

  buf | - Pointer to the structure where info it to be returned.

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 51 of file XrdOssHandler.hh.

{ return successor_->Fstat(buff); }

References stat, and successor_.

## Fsync() [1/2]

virtual int XrdOssDFHandler::Fsync | ( | void |  | ) |

inline virtual

Synchronize associated file with media (synchronous).

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 52 of file XrdOssHandler.hh.

{ return successor_->Fsync(); }

References successor_.

## Fsync() [2/2]

virtual int XrdOssDFHandler::Fsync | ( | XrdSfsAio * | aiop | ) |

inline virtual

Synchronize associated file with media (asynchronous).

Parameters

  aiop | - Pointer to async I/O request object.

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 53 of file XrdOssHandler.hh.

{ return successor_->Fsync(aiop); }

References successor_.

## Ftruncate()

virtual int XrdOssDFHandler::Ftruncate | ( | unsigned long long | flen | ) |

inline virtual

Set the size of the associated file.

Parameters

  flen | - The new size of the file.

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 54 of file XrdOssHandler.hh.

{ return successor_->Ftruncate(flen); }

References successor_.

## getFD()

virtual int XrdOssDFHandler::getFD | ( |  | ) |

inline virtual

Return the underlying file descriptor.

Returns
  -1 if there is no file descriptor or a non-negative FD number.

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 55 of file XrdOssHandler.hh.

{ return successor_->getFD(); }

References successor_.

Referenced by XrdOssDFHandler().

Here is the caller graph for this function:

## getMmap()

virtual off_t XrdOssDFHandler::getMmap | ( | void ** | addr | ) |

inline virtual

Return the memory mapped characteristics of the file.

Parameters

  addr | - Pointer to where the memory mapped address is to be returned.

Returns
  If mapped, the size of the file is returned and it memory location is placed in addr. Otherwise, addr is set to zero and zero is returned. Note that zero length files cannot be memory mapped.

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 56 of file XrdOssHandler.hh.

{ return successor_->getMmap(addr); }

References successor_.

## getTID()

virtual const char * XrdOssDFHandler::getTID | ( |  | ) |

inline virtual

Return trace identifier associated with this object.

Returns
  Pointer to trace identifier

Reimplemented from XrdOssDF.

Definition at line 75 of file XrdOssHandler.hh.

{ return successor_->getTID(); }

References successor_.

Referenced by XrdOssDFHandler().

Here is the caller graph for this function:

## isCompressed()

virtual int XrdOssDFHandler::isCompressed | ( | char * | cxidp = 0 | ) |

inline virtual

Return file compression charectistics.

Parameters

  cxidp | - Pointer to where the compression algorithm name returned.

Returns
  If the file is compressed, the region size if returned. Otherwise, zero is returned (file not compressed).

Reimplemented from XrdOssDF.

Definition at line 57 of file XrdOssHandler.hh.

{ return successor_->isCompressed(cxidp); }

References successor_.

## Open()

virtual int XrdOssDFHandler::Open | ( | const char * | path,
|  | int | Oflag,
|  | mode_t | Mode,
|  | XrdOucEnv & | env )

inline virtual

Open a file.

Parameters

  path | - Pointer to the path of the file to be opened.
  Oflag | - Standard open flags.
  Mode | - File open mode (ignored unless creating a file).
  env | - Reference to environmental information.

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 58 of file XrdOssHandler.hh.

{ return successor_->Open(path, Oflag, Mode, Env); }

References Mode, and successor_.

## Opendir()

virtual int XrdOssDFHandler::Opendir | ( | const char * | path,
|  | XrdOucEnv & | env )

inline virtual

Open a directory.

Parameters

  path | - Pointer to the path of the directory to be opened.
  env | - Reference to environmental information.

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiDir.

Definition at line 44 of file XrdOssHandler.hh.

{ return successor_->Opendir(dir_path, Env); }

References successor_.

## pgRead() [1/2]

virtual ssize_t XrdOssDFHandler::pgRead | ( | void * | buffer,
|  | off_t | offset,
|  | size_t | rdlen,
|  | uint32_t * | csvec,
|  | uint64_t | opts )

inline virtual

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 59 of file XrdOssHandler.hh.

{ return successor_->pgRead(buffer, offset, rdlen, csvec, opts); }
opts
struct myOpts opts

References opts, and successor_.

## pgRead() [2/2]

virtual int XrdOssDFHandler::pgRead | ( | XrdSfsAio * | aioparm,
|  | uint64_t | opts )

inline virtual

Read file pages and checksums using asynchronous I/O.

Parameters

  aioparm | - Pointer to async I/O object controlling the I/O.
  opts | - Processing options (see above).

Returns
  0 upon if request started success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 60 of file XrdOssHandler.hh.

{ return successor_->pgRead(aioparm, opts); }

References opts, and successor_.

## pgWrite() [1/2]

virtual ssize_t XrdOssDFHandler::pgWrite | ( | void * | buffer,
|  | off_t | offset,
|  | size_t | wrlen,
|  | uint32_t * | csvec,
|  | uint64_t | opts )

inline virtual

Write file pages into a file with corresponding checksums.

Parameters

  buffer | - pointer to buffer containing the bytes to write.
  offset | - The offset where the write is to start.
  wrlen | - The number of bytes to write.
  csvec | - A vector which contains the corresponding CRC32 checksum for each page. See XrdOucPgrwUtils::csNum() for sizing.
  opts | - Processing options (see above).

Returns
  >= 0 The number of bytes written upon success. or -errno or -osserr upon failure. (see XrdOssError.hh).
  < 0 -errno or -osserr upon failure. (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 61 of file XrdOssHandler.hh.

{ return successor_->pgWrite(buffer, offset, wrlen, csvec, opts); }

References opts, and successor_.

## pgWrite() [2/2]

virtual int XrdOssDFHandler::pgWrite | ( | XrdSfsAio * | aioparm,
|  | uint64_t | opts )

inline virtual

Write file pages and checksums using asynchronous I/O.

Parameters

  aioparm | - Pointer to async I/O object controlling the I/O.
  opts | - Processing options (see above).

Returns
  0 upon if request started success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 62 of file XrdOssHandler.hh.

{ return successor_->pgWrite(aioparm, opts); }

References opts, and successor_.

## Read() [1/3]

virtual ssize_t XrdOssDFHandler::Read | ( | off_t | offset,
|  | size_t | size )

inline virtual

Preread file blocks into the file system cache.

Parameters

  offset | - The offset where the read is to start.
  size | - The number of bytes to pre-read.

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 63 of file XrdOssHandler.hh.

{ return successor_->Read(offset, blen); }

References successor_.

## Read() [2/3]

virtual ssize_t XrdOssDFHandler::Read | ( | void * | buffer,
|  | off_t | offset,
|  | size_t | size )

inline virtual

Read file bytes into a buffer.

Parameters

  buffer | - pointer to buffer where the bytes are to be placed.
  offset | - The offset where the read is to start.
  size | - The number of bytes to read.

Returns
  >= 0 The number of bytes that placed in buffer.
  < 0 -errno or -osserr upon failure (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 64 of file XrdOssHandler.hh.

{ return successor_->Read(buff, offset, blen); }

References successor_.

## Read() [3/3]

virtual int XrdOssDFHandler::Read | ( | XrdSfsAio * | aiop | ) |

inline virtual

Read file bytes using asynchronous I/O.

Parameters

  aiop | - Pointer to async I/O object controlling the I/O.

Returns
  0 upon if request started success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 65 of file XrdOssHandler.hh.

{ return successor_->Read(aiop); }

References successor_.

## Readdir()

virtual int XrdOssDFHandler::Readdir | ( | char * | buff,
|  | int | blen )

inline virtual

Get the next directory entry.

Parameters

  buff | - Pointer to buffer where a null terminated string of the entry name is to be returned. If no more entries exist, a null string is returned.
  blen | - Length of the buffer.

Returns
  0 upon success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiDir.

Definition at line 45 of file XrdOssHandler.hh.

{ return successor_->Readdir(buff, blen); }

References successor_.

## ReadRaw()

virtual ssize_t XrdOssDFHandler::ReadRaw | ( | void * | buffer,
|  | off_t | offset,
|  | size_t | size )

inline virtual

Read uncompressed file bytes into a buffer.

Parameters

  buffer | - pointer to buffer where the bytes are to be placed.
  offset | - The offset where the read is to start.
  size | - The number of bytes to read.

Returns
  >= 0 The number of bytes that placed in buffer.
  < 0 -errno or -osserr upon failure (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 66 of file XrdOssHandler.hh.

{ return successor_->ReadRaw(buff, offset, blen); }

References successor_.

## ReadV()

virtual ssize_t XrdOssDFHandler::ReadV | ( | XrdOucIOVec * | readV,
|  | int | rdvcnt )

inline virtual

Read file bytes as directed by the read vector.

Parameters

  readV | pointer to the array of read requests.
  rdvcnt | the number of elements in readV.

Returns
  >=0 The numbe of bytes read.
  < 0 -errno or -osserr upon failure (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 67 of file XrdOssHandler.hh.

{ return successor_->ReadV(readV, n); }

References successor_.

## StatRet()

virtual int XrdOssDFHandler::StatRet | ( | struct stat * | buff | ) |

inline virtual

Set the stat() buffer where stat information is to be placed corresponding to the directory entry returned by Readdir().

Parameters

  buff | - Pointer to stat structure to be used.

Returns
  0 upon success or -ENOTSUP if not supported.

Note
  This is a one-time call as stat structure is reused for each Readdir.
  When StatRet() is in effect, directory entries that have been deleted from the target directory are quietly skipped.

Reimplemented from XrdOssDF.

Definition at line 46 of file XrdOssHandler.hh.

{ return successor_->StatRet(buff); }

References stat, and successor_.

## Write() [1/2]

virtual ssize_t XrdOssDFHandler::Write | ( | const void * | buffer,
|  | off_t | offset,
|  | size_t | size )

inline virtual

Write file bytes from a buffer.

Parameters

  buffer | - pointer to buffer where the bytes reside.
  offset | - The offset where the write is to start.
  size | - The number of bytes to write.

Returns
  >= 0 The number of bytes that were written.
  < 0 -errno or -osserr upon failure (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 68 of file XrdOssHandler.hh.

{ return successor_->Write(buff, offset, blen); }

References successor_.

## Write() [2/2]

virtual int XrdOssDFHandler::Write | ( | XrdSfsAio * | aiop | ) |

inline virtual

Write file bytes using asynchronous I/O.

Parameters

  aiop | - Pointer to async I/O object controlling the I/O.

Returns
  0 upon if request started success or -errno or -osserr (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 69 of file XrdOssHandler.hh.

{ return successor_->Write(aiop); }

References successor_.

## WriteV()

virtual ssize_t XrdOssDFHandler::WriteV | ( | XrdOucIOVec * | writeV,
|  | int | wrvcnt )

inline virtual

Write file bytes as directed by the write vector.

Parameters

  writeV | pointer to the array of write requests.
  wrvcnt | the number of elements in writeV.

Returns
  >=0 The numbe of bytes read.
  < 0 -errno or -osserr upon failure (see XrdOssError.hh).

Reimplemented from XrdOssDF.

Reimplemented in XrdOssCsiFile.

Definition at line 70 of file XrdOssHandler.hh.

{ return successor_->WriteV(writeV, n); }

References successor_.

## Member Data Documentation

## successor_

XrdOssDF* XrdOssDFHandler::successor_

protected

Definition at line 81 of file XrdOssHandler.hh.

Referenced by XrdOssDFHandler(), ~XrdOssDFHandler(), XrdOssCsiFile::Close(), Close(), Fchmod(), Fctl(), XrdOssCsiFile::Flush(), Flush(), XrdOssCsiFile::Fstat(), Fstat(), XrdOssCsiFile::Fsync(), Fsync(), Fsync(), XrdOssCsiFile::Ftruncate(), Ftruncate(), XrdOssCsiFile::getFD(), getFD(), getMmap(), getTID(), isCompressed(), XrdOssCsiFile::Open(), Open(), XrdOssCsiDir::Opendir(), Opendir(), XrdOssCsiFile::pgRead(), pgRead(), pgRead(), XrdOssCsiFile::pgWrite(), pgWrite(), pgWrite(), XrdOssCsiFile::Read(), XrdOssCsiFile::Read(), Read(), Read(), Read(), XrdOssCsiDir::Readdir(), Readdir(), XrdOssCsiFile::ReadRaw(), ReadRaw(), XrdOssCsiFile::ReadV(), ReadV(), StatRet(), XrdOssCsiFile::Write(), Write(), Write(), XrdOssCsiFile::WriteV(), and WriteV().

The documentation for this class was generated from the following file:

- XrdOssHandler.hh